/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gprobocode.func;

import ec.*;
import ec.gp.*;
import ec.util.*;

import gprobocode.*;

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

public abstract class BasicAction extends GPNode implements Constants {

    public abstract String toString();

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 0)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        action((GPRobocode) problem, (GPRobocodeData) input);


    }

    protected abstract void action(GPRobocode gprobocode,
                                   GPRobocodeData input);
}

