/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gproboproxy;

import java.util.Properties;

import ec.*;
import ec.gp.*;

import robocode.*;
import gprobocode.*;

/**
 * <p>Title: GPTankProxy/p>
 * <p>Description: An adapting interface between Robocode and ECJ</p>
 * <p>Universita` degli Studi di Pavia</p>
 * @author Marco Piastra
 * @version 2003-5-30
 */

public final class GPTankProxy extends GPTank {

    // Each robocode's run involves a new instance
    // The only safe place to store an individual is in a static var
    protected static GPIndividual individual;

    public void setIndividual(GPIndividual ind) {
        individual = ind;
    }

    public GPIndividual getIndividual() {
        return individual;
    }
}

